<?php
//***************************************************************
// Script de redirection sur l'adresse IP enregistrée dans
// un fichier m.à-j. depuis la fonction "fichier"?action=ipupdate
//
// Autheur: SyJe
// Date:	2019-09-03
//***************************************************************

// Affiche ou non les erreurs PHP du scripts (PAS RECOMMANDÉ)
error_reporting(0);  // Reporte toutes les erreurs (-1) pour les tests

// Définir les variables
  $iprefresh = 3600; // durée du rafraichissement des pages
  $ipfile = "monip.txt"; // nom du fichier contenant l'adresse IP

// A VENIR
  $logfile = "log.txt"; // nom du fichier des logs de connexion client

// A VENIR
  // Les ports pour vérification fsocket 
  $porthttp = 80;
  $porthttps = 443;
  $portftp = 21;
  $portsql = 3004;
  
// Vérifier la présence du fichier sinon on par sur la fonction de m.-à-j.
if ( file_exists( $ipfile ) )
  {
  // OK le fichier existe
  }
  else // Sinon on par sur la fonction de m.-à-j. "ipupdate"
  {
	  $_GET['action'] = 'ipupdate';
  }

//***************************************************************
// Fonction de redirection (par défaut) 
//***************************************************************
function iphome($iprefresh,$ipfile)
{
// On ouvre le fichier de l'IP, on lit la premiere ligne et on referme le fichier
  $fichier = fopen($ipfile,"r");
  $ip = fgets($fichier,255);
  fclose($fichier);
// Mise en forme de l'adresse IP
  $ip = str_replace (" inet adr:","",$ip);
  //  $ip = str_replace (" P-t-P:91.235.247.252 Masque:255.255.255.255","",$ip);
  $ip = str_replace ("\n","",$ip);
  $ip = "https://".$ip;
// Page HTML/PHP/Javascript de redirection
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="refresh" content="<?php echo $iprefresh; ?>;<?php echo $_SERVER['PHP_SELF']; ?>" />
  <title>Redirection</title>
  <meta name="robots" content="noindex, nofollow" />
  <link href="style.css" rel="stylesheet" type="text/css" />
</head>
<body>
<script language='javascript'>
function redirection()
{
window.location="<? echo $ip; ?>";
}
</script>
<!-- Redirection automatique au chargement de la page -->
<body onLoad="redirection()">
<table cellpadding="3" class="table">
  <tr>
    <td colspan="2" class="border-top">Redirection</td>
  </tr>
  <tr>
    <td><p><div align="center"><a href="<? echo $ip; ?>" target="_blank">Cliquez ici si vous n'etes pas redirigé<br />Click here if you're not redirected</a></div></p></td>
  </tr>
    <tr>
    <td class="border-buttom"><div align="right">Script NO-&copy; by SyJe</div></td>
  </tr>
</table>
</body>
</html> 
<?php
}


//***************************************************************
// Fonction de m.-à-j. de l'adresse IP dans le fichier 
//***************************************************************
function ipupdate($iprefresh,$ipfile)
{
// Définis la variable $ip du client "remote"
  $ip = $_SERVER['REMOTE_ADDR'];
// Page HTML/PHP/Javascript de redirection
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="refresh" content="<?php echo $iprefresh; ?>;<?php echo $_SERVER['PHP_SELF'].'?action=ipupdate'; ?>" />
  <title>Mise à jour du fichier IP</title>
  <meta name="robots" content="noindex, nofollow" />
  <link href="style.css" rel="stylesheet" type="text/css" />
</head>
<body>
<!-- Tableau HTML/PHP contenant les informations -->
<table cellpadding="3" class="table">
  <tr>
    <td colspan="2" class="border-top">Mise à jour du fichier IP</td>
  </tr>
  <tr>
    <td width="200"><div align="right">Mise &agrave; jour du fichier :</div></td>
    <td><a href="<?php echo $ipfile; ?>" target="_blank"><?php echo $ipfile; ?></a></td>
  </tr>
  <tr>
    <td><div align="right">le :</div></td>
    <td><?php echo date ('d-m-Y'); ?></td>
  </tr>
  <tr>
    <td><div align="right">&agrave; :</div></td>
    <td><?php echo date ('H:i:s'); ?></td>
  </tr>
  <tr>
    <td><div align="right">A l'adresse IP v4:</div></td>
    <td><a href="<?php echo $_SERVER['PHP_SELF']; ?>" target="_blank"><?php echo $_SERVER['REMOTE_ADDR']; ?></td>
  </tr>
  <tr>
    <td><div align="right">Taux de rafra&icirc;chissement :</div></td>
    <td><?php echo $iprefresh; ?> sec.</td>
  </tr>
  <tr class="info">
    <td colspan="2" class="info">La vitesse de rafraichissemnt le nom du fichier contenant l'adresse IP de redirection<br />
	ainsi que les ports ouverts sont definit en dur dans le fichier index.php (voir définition des variables).</td>
  </tr>
  <tr>
    <td colspan="2" class="border-buttom"><div align="right">Script NO-&copy; by SyJe</div></td>
  </tr>
</table>
</body>
</html>
<?php
// Créer ou réinitialise le fichier contenant l'IP
  $fichier=fopen($ipfile,'wb');
// Ecrit l'IP dans le fichier
  fputs($fichier,$ip);
// Ferme le fichier
  fclose ($fichier);
exit;
}

//***************************************************************
// Liste des actions 
//***************************************************************
switch($_GET['action'])
{
  default:
  iphome($iprefresh,$ipfile);
  break;

  case 'ipupdate':
  ipupdate($iprefresh,$ipfile);
  break;
}

?>
